blob: 8bd5584e692383ec37166d1577a5389e7e495176 [file] [log] [blame]
cgeoffroy549e20f2017-03-03 16:10:40 +01001#!/bin/bash
2export DOCKER_HOST="unix:///var/run/docker.sock"
3
4set -e
5set -x
6
7W() {
cgeoffroy349dc0b2017-03-15 16:24:58 +01008 # Wait until a line appears in the screen session.
9 # It starts from the beginning of the log and exits after the first match.
10 local T=${2:-20s}
11 #timeout -k 3s ${T} stdbuf -o0 grep -q -m 1 "^${1}" <(tail -F -n+0 screenlog.0)
12 # (HACK) As Jenkins blocks subshell, we must use an intermediate script
13 local SUBF=$(mktemp)
14 chmod +x ${SUBF}
15 cat > ${SUBF} <<- EOF
16 #!/bin/bash -e
17 while true; do
18 if strings screenlog.0 | grep -m 1 "\${1}"; then
19 exit 0
20 fi
21 sleep 0.5s
22 done
23 EOF
cgeoffroy0412c622017-04-11 10:58:53 +020024 local RES=0
25 timeout -k 3s ${T} ${SUBF} "${1}" || RES=$?
cgeoffroy349dc0b2017-03-15 16:24:58 +010026 rm -f ${SUBF}
cgeoffroy0412c622017-04-11 10:58:53 +020027 if [ ! "$RES" = "0" ]; then
28 sync
cgeoffroy5ca7aae2017-04-11 11:20:23 +020029 echo -e "\n\n\n(Debug) Error while waiting for a pattern to appear in screenlog.0\n\n\n"
cgeoffroy0412c622017-04-11 10:58:53 +020030 strings screenlog.0
31 fi
cgeoffroy349dc0b2017-03-15 16:24:58 +010032 return ${RES}
cgeoffroy549e20f2017-03-03 16:10:40 +010033}
34
35Cmd() {
36 # Send a command to the screen session, aka into the containernet prompt
37 screen -S sonemu -X stuff "${1}^M"
38}
39
cgeoffroy7bb91b12017-04-12 10:49:52 +020040Vnf() {
41 # Send a command inside the vnf1 container
42 docker exec -t "mn.${1}" /bin/bash -c "${2}" && sync
43}
44
cgeoffroy549e20f2017-03-03 16:10:40 +010045
46if ! screen --version | grep 'Screen version'; then
47 # Install screen and do an initial cleanup
48 sudo apt-get update -qq -y
49 sudo apt-get install -y screen
50 screen --version | grep 'Screen version'
51fi
cgeoffroyae307a92017-03-17 10:48:26 +010052if ! timeout --version; then
53 # Install coreutils for the timeout command
54 sudo apt-get update -qq -y
55 sudo apt-get install -y coreutils
56 timeout --version
57fi
cgeoffroy549e20f2017-03-03 16:10:40 +010058# Initial cleanup
cgeoffroye2a48492017-04-12 10:48:34 +020059pkill --signal KILL -f 'SCREEN -L -S sonemu' || true
60sleep 1s
cgeoffroy549e20f2017-03-03 16:10:40 +010061screen -wipe || true
62rm -f screenlog.0
63
64
65# Start containernet with a topology
cgeoffroy4b9ba682017-03-17 12:51:18 +010066screen -L -S sonemu -d -m sudo python src/emuvim/examples/simple_topology.py
cgeoffroy549e20f2017-03-03 16:10:40 +010067# Setup screen for immediate flusing
68screen -S sonemu -X logfile flush 0
69# Wait for the cli to start
cgeoffroy736c4aa2017-03-17 11:48:15 +010070W '^*** Starting CLI:' 60s
cgeoffroy549e20f2017-03-03 16:10:40 +010071# Print nodes
72Cmd 'nodes'
73# Start vnf1
74son-emu-cli compute start -d datacenter1 -n vnf1 && sleep 1s
75# Start vnf2
76son-emu-cli compute start -d datacenter1 -n vnf2 && sleep 1s
77# List compute nodes
78son-emu-cli compute list && sleep 1s
cgeoffroy6f86be72017-03-17 13:26:50 +010079sync # avoid text overlapping
cgeoffroy1d6978b2017-04-11 11:05:56 +020080# Gather some infos
cgeoffroy75591cd2017-04-11 11:21:27 +020081Cmd 'sh sync'
82Cmd 'sh echo "... starting various checks"'
cgeoffroy7bb91b12017-04-12 10:49:52 +020083sync # avoid text overlappin
84Cmd 'links'
85Vnf vnf1 'ifconfig'
86Vnf vnf2 'ifconfig'
cgeoffroy549e20f2017-03-03 16:10:40 +010087# Try to ping vnfs
cgeoffroy7bb91b12017-04-12 10:49:52 +020088IP_2=$(Vnf vnf2 'ip -f inet -o addr show vnf2-eth0' | cut -d\ -f 7 | cut -d/ -f 1)
89# IP_1=$(Vnf vnf1 'ip -f inet -o addr show vnf1-eth0' | cut -d\ -f 7 | cut -d/ -f 1)
90OUTPUT_A=$(Vnf vnf1 "ping -v -c 2 ${IP_2}")
cgeoffroy549e20f2017-03-03 16:10:40 +010091Cmd 'quit'
92# Wait for sonemu to end
cgeoffroy1d6978b2017-04-11 11:05:56 +020093W '*** Done'
cgeoffroy549e20f2017-03-03 16:10:40 +010094
cgeoffroy349dc0b2017-03-15 16:24:58 +010095echo -e '\n\n******************* Result ******************\n\n'
cgeoffroy549e20f2017-03-03 16:10:40 +010096strings screenlog.0
97echo -e '\n\n*********************************************\n\n'
98
99
100# Check the ping result
cgeoffroy7bb91b12017-04-12 10:49:52 +0200101if echo ${OUTPUT_A} | grep ', 2 received'; then
cgeoffroy549e20f2017-03-03 16:10:40 +0100102 echo 'No problems detected'
103 exit 0
104else
105 echo 'Ping is broken !'
106 exit 1
107fi